diff --git a/lisp/ido.el b/lisp/ido.el
index bedf00e..eb42f4e 100644
--- a/lisp/ido.el
+++ b/lisp/ido.el
@@ -3159,8 +3159,7 @@ Use `eq' for comparison."
 	(sofar nil))
     (while (not ret)
       (setq next (car items))
-      ;; Use `eq' to avoid bug http://debbugs.gnu.org/10994
-      (if (eq next elem)
+      (if (equal next elem)
 	  (setq ret (append items (nreverse sofar)))
 	;; else
 	(progn
@@ -3462,7 +3461,7 @@ This is to make them appear as if they were \"virtual buffers\"."
   ;; Return the current list of choices.
   ;; If DEFAULT is non-nil, and corresponds to an element of choices,
   ;; it is put to the start of the list.
-  (let ((ido-temp-list ido-choice-list))
+  (let ((ido-temp-list (delete-dups ido-choice-list)))
     (if default
 	(progn
 	  (setq ido-temp-list
